diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-client.cc ns-3.47/src/applications/model/udp-client.cc
--- ns-3.46/src/applications/model/udp-client.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-client.cc	2026-02-16 16:08:49.572229900 -0800
@@ -75,10 +75,6 @@
                           UintegerValue(1024),
                           MakeUintegerAccessor(&UdpClient::m_size),
                           MakeUintegerChecker<uint32_t>(12, 65507))
-            .AddTraceSource("Tx",
-                            "A new packet is created and sent",
-                            MakeTraceSourceAccessor(&UdpClient::m_txTrace),
-                            "ns3::Packet::TracedCallback")
             .AddTraceSource("TxWithAddresses",
                             "A new packet is created and sent",
                             MakeTraceSourceAccessor(&UdpClient::m_txTraceWithAddresses),
@@ -87,13 +83,10 @@
 }
 
 UdpClient::UdpClient()
-    : m_sent{0},
-      m_totalTx{0},
-      m_socket{nullptr},
-      m_peerPort{},
-      m_sendEvent{}
+    : SourceApplication(false)
 {
     NS_LOG_FUNCTION(this);
+    m_protocolTid = TypeId::LookupByName("ns3::UdpSocketFactory");
 }
 
 UdpClient::~UdpClient()
@@ -164,53 +157,11 @@
 }
 
 void
-UdpClient::StartApplication()
+UdpClient::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
 
-    if (!m_socket)
-    {
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket = Socket::CreateSocket(GetNode(), tid);
-        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
-        if (!m_local.IsInvalid())
-        {
-            NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
-                             InetSocketAddress::IsMatchingType(m_local)) ||
-                                (InetSocketAddress::IsMatchingType(m_peer) &&
-                                 Inet6SocketAddress::IsMatchingType(m_local)),
-                            "Incompatible peer and local address IP version");
-            if (m_socket->Bind(m_local) == -1)
-            {
-                NS_FATAL_ERROR("Failed to bind socket");
-            }
-        }
-        else
-        {
-            if (InetSocketAddress::IsMatchingType(m_peer))
-            {
-                if (m_socket->Bind() == -1)
-                {
-                    NS_FATAL_ERROR("Failed to bind socket");
-                }
-            }
-            else if (Inet6SocketAddress::IsMatchingType(m_peer))
-            {
-                if (m_socket->Bind6() == -1)
-                {
-                    NS_FATAL_ERROR("Failed to bind socket");
-                }
-            }
-            else
-            {
-                NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
-            }
-        }
-        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-        m_socket->Connect(m_peer);
-        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-        m_socket->SetAllowBroadcast(true);
-    }
+    m_socket->SetAllowBroadcast(true);
 
 #ifdef NS3_LOG_ENABLE
     std::stringstream peerAddressStringStream;
@@ -228,14 +179,7 @@
     m_peerString = peerAddressStringStream.str();
 #endif // NS3_LOG_ENABLE
 
-    m_sendEvent = Simulator::Schedule(Seconds(0), &UdpClient::Send, this);
-}
-
-void
-UdpClient::StopApplication()
-{
-    NS_LOG_FUNCTION(this);
-    Simulator::Cancel(m_sendEvent);
+    m_sendEvent = Simulator::ScheduleNow(&UdpClient::Send, this);
 }
 
 void
@@ -281,6 +225,13 @@
     }
 }
 
+void
+UdpClient::CancelEvents()
+{
+    NS_LOG_FUNCTION(this);
+    Simulator::Cancel(m_sendEvent);
+}
+
 uint64_t
 UdpClient::GetTotalTx() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-client.h ns-3.47/src/applications/model/udp-client.h
--- ns-3.46/src/applications/model/udp-client.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-client.h	2026-02-16 16:08:49.572229900 -0800
@@ -24,7 +24,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 
 /**
@@ -63,8 +62,8 @@
     uint64_t GetTotalTx() const;
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
+    void CancelEvents() override;
 
     /**
      * @brief Send a packet
@@ -89,9 +88,6 @@
      */
     Address GetRemote() const;
 
-    /// Traced Callback: transmitted packets.
-    TracedCallback<Ptr<const Packet>> m_txTrace;
-
     /// Callbacks for tracing the packet Tx events, includes source and destination addresses
     TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_txTraceWithAddresses;
 
@@ -99,9 +95,8 @@
     Time m_interval;  //!< Packet inter-send time
     uint32_t m_size;  //!< Size of the sent packet (including the SeqTsHeader)
 
-    uint32_t m_sent;                    //!< Counter for sent packets
-    uint64_t m_totalTx;                 //!< Total bytes sent
-    Ptr<Socket> m_socket;               //!< Socket
+    uint32_t m_sent{0};                 //!< Counter for sent packets
+    uint64_t m_totalTx{0};              //!< Total bytes sent
     std::optional<uint16_t> m_peerPort; //!< Remote peer port (deprecated) // NS_DEPRECATED_3_44
     EventId m_sendEvent;                //!< Event to send the next packet
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-echo-client.cc ns-3.47/src/applications/model/udp-echo-client.cc
--- ns-3.46/src/applications/model/udp-echo-client.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-echo-client.cc	2026-02-16 16:08:49.572229900 -0800
@@ -67,10 +67,6 @@
                 UintegerValue(100),
                 MakeUintegerAccessor(&UdpEchoClient::SetDataSize, &UdpEchoClient::GetDataSize),
                 MakeUintegerChecker<uint32_t>())
-            .AddTraceSource("Tx",
-                            "A new packet is created and is sent",
-                            MakeTraceSourceAccessor(&UdpEchoClient::m_txTrace),
-                            "ns3::Packet::TracedCallback")
             .AddTraceSource("Rx",
                             "A packet has been received",
                             MakeTraceSourceAccessor(&UdpEchoClient::m_rxTrace),
@@ -87,20 +83,15 @@
 }
 
 UdpEchoClient::UdpEchoClient()
-    : m_dataSize{0},
-      m_data{nullptr},
-      m_sent{0},
-      m_socket{nullptr},
-      m_peerPort{},
-      m_sendEvent{}
+    : SourceApplication(false)
 {
     NS_LOG_FUNCTION(this);
+    m_protocolTid = TypeId::LookupByName("ns3::UdpSocketFactory");
 }
 
 UdpEchoClient::~UdpEchoClient()
 {
     NS_LOG_FUNCTION(this);
-    m_socket = nullptr;
 
     delete[] m_data;
     m_data = nullptr;
@@ -170,70 +161,12 @@
 }
 
 void
-UdpEchoClient::StartApplication()
+UdpEchoClient::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
-
-    if (!m_socket)
-    {
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket = Socket::CreateSocket(GetNode(), tid);
-        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
-        if (!m_local.IsInvalid())
-        {
-            NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
-                             InetSocketAddress::IsMatchingType(m_local)) ||
-                                (InetSocketAddress::IsMatchingType(m_peer) &&
-                                 Inet6SocketAddress::IsMatchingType(m_local)),
-                            "Incompatible peer and local address IP version");
-            if (m_socket->Bind(m_local) == -1)
-            {
-                NS_FATAL_ERROR("Failed to bind socket");
-            }
-        }
-        else
-        {
-            if (InetSocketAddress::IsMatchingType(m_peer))
-            {
-                if (m_socket->Bind() == -1)
-                {
-                    NS_FATAL_ERROR("Failed to bind socket");
-                }
-            }
-            else if (Inet6SocketAddress::IsMatchingType(m_peer))
-            {
-                if (m_socket->Bind6() == -1)
-                {
-                    NS_FATAL_ERROR("Failed to bind socket");
-                }
-            }
-            else
-            {
-                NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
-            }
-        }
-        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-        m_socket->Connect(m_peer);
-        m_socket->SetRecvCallback(MakeCallback(&UdpEchoClient::HandleRead, this));
-        m_socket->SetAllowBroadcast(true);
-    }
-
-    ScheduleTransmit(Seconds(0.));
-}
-
-void
-UdpEchoClient::StopApplication()
-{
-    NS_LOG_FUNCTION(this);
-
-    if (m_socket)
-    {
-        m_socket->Close();
-        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-        m_socket = nullptr;
-    }
-
-    Simulator::Cancel(m_sendEvent);
+    m_socket->SetRecvCallback(MakeCallback(&UdpEchoClient::HandleRead, this));
+    m_socket->SetAllowBroadcast(true);
+    ScheduleTransmit(Time(0));
 }
 
 void
@@ -255,7 +188,6 @@
 uint32_t
 UdpEchoClient::GetDataSize() const
 {
-    NS_LOG_FUNCTION(this);
     return m_size;
 }
 
@@ -434,4 +366,11 @@
     }
 }
 
+void
+UdpEchoClient::CancelEvents()
+{
+    NS_LOG_FUNCTION(this);
+    Simulator::Cancel(m_sendEvent);
+}
+
 } // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-echo-client.h ns-3.47/src/applications/model/udp-echo-client.h
--- ns-3.46/src/applications/model/udp-echo-client.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-echo-client.h	2026-02-16 16:08:49.572229900 -0800
@@ -20,7 +20,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 
 /**
@@ -122,8 +121,8 @@
     void SetFill(uint8_t* fill, uint32_t fillSize, uint32_t dataSize);
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
+    void CancelEvents() override;
 
     /**
      * @brief Set the remote port (temporary function until deprecated attributes are removed)
@@ -166,17 +165,13 @@
     Time m_interval;  //!< Packet inter-send time
     uint32_t m_size;  //!< Size of the sent packet
 
-    uint32_t m_dataSize; //!< packet payload size (must be equal to m_size)
-    uint8_t* m_data;     //!< packet payload data
+    uint32_t m_dataSize{0};   //!< packet payload size (must be equal to m_size)
+    uint8_t* m_data{nullptr}; //!< packet payload data
 
-    uint32_t m_sent;                    //!< Counter for sent packets
-    Ptr<Socket> m_socket;               //!< Socket
+    uint32_t m_sent{0};                 //!< Counter for sent packets
     std::optional<uint16_t> m_peerPort; //!< Remote peer port (deprecated) // NS_DEPRECATED_3_44
     EventId m_sendEvent;                //!< Event to send the next packet
 
-    /// Callbacks for tracing the packet Tx events
-    TracedCallback<Ptr<const Packet>> m_txTrace;
-
     /// Callbacks for tracing the packet Rx events
     TracedCallback<Ptr<const Packet>> m_rxTrace;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-echo-server.cc ns-3.47/src/applications/model/udp-echo-server.cc
--- ns-3.46/src/applications/model/udp-echo-server.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-echo-server.cc	2026-02-16 16:08:49.572229900 -0800
@@ -41,10 +41,6 @@
                           UintegerValue(0),
                           MakeUintegerAccessor(&UdpEchoServer::m_tos),
                           MakeUintegerChecker<uint8_t>())
-            .AddTraceSource("Rx",
-                            "A packet has been received",
-                            MakeTraceSourceAccessor(&UdpEchoServer::m_rxTrace),
-                            "ns3::Packet::TracedCallback")
             .AddTraceSource("RxWithAddresses",
                             "A packet has been received",
                             MakeTraceSourceAccessor(&UdpEchoServer::m_rxTraceWithAddresses),
@@ -53,61 +49,49 @@
 }
 
 UdpEchoServer::UdpEchoServer()
-    : SinkApplication(DEFAULT_PORT),
-      m_socket{nullptr},
-      m_socket6{nullptr}
+    : SinkApplication(DEFAULT_PORT)
 {
     NS_LOG_FUNCTION(this);
+    m_protocolTid = TypeId::LookupByName("ns3::UdpSocketFactory");
 }
 
 UdpEchoServer::~UdpEchoServer()
 {
     NS_LOG_FUNCTION(this);
-    m_socket = nullptr;
-    m_socket6 = nullptr;
 }
 
 void
-UdpEchoServer::StartApplication()
+UdpEchoServer::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
 
-    if (!m_socket)
+    auto local = m_local;
+    if (local.IsInvalid())
+    {
+        local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+    }
+    if (m_socket->Bind(local) == -1)
     {
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket = Socket::CreateSocket(GetNode(), tid);
-        auto local = m_local;
-        if (local.IsInvalid())
+        NS_FATAL_ERROR("Failed to bind socket");
+    }
+    if (addressUtils::IsMulticast(m_local))
+    {
+        Ptr<UdpSocket> udpSocket = DynamicCast<UdpSocket>(m_socket);
+        if (udpSocket)
         {
-            local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+            // equivalent to setsockopt (MCAST_JOIN_GROUP)
+            udpSocket->MulticastJoinGroup(0, m_local);
         }
-        if (m_socket->Bind(local) == -1)
+        else
         {
-            NS_FATAL_ERROR("Failed to bind socket");
-        }
-        if (addressUtils::IsMulticast(m_local))
-        {
-            Ptr<UdpSocket> udpSocket = DynamicCast<UdpSocket>(m_socket);
-            if (udpSocket)
-            {
-                // equivalent to setsockopt (MCAST_JOIN_GROUP)
-                udpSocket->MulticastJoinGroup(0, m_local);
-            }
-            else
-            {
-                NS_FATAL_ERROR("Error: Failed to join multicast group");
-            }
+            NS_FATAL_ERROR("Error: Failed to join multicast group");
         }
-        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-        m_socket->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
     }
+    m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+    m_socket->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
 
-    if (m_local.IsInvalid() && !m_socket6)
+    if (m_local.IsInvalid())
     {
-        // local address is not specified, so create another socket to also listen to all IPv6
-        // addresses
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket6 = Socket::CreateSocket(GetNode(), tid);
         auto local = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
         if (m_socket6->Bind(local) == -1)
         {
@@ -131,23 +115,6 @@
 }
 
 void
-UdpEchoServer::StopApplication()
-{
-    NS_LOG_FUNCTION(this);
-
-    if (m_socket)
-    {
-        m_socket->Close();
-        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    }
-    if (m_socket6)
-    {
-        m_socket6->Close();
-        m_socket6->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    }
-}
-
-void
 UdpEchoServer::HandleRead(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
@@ -157,7 +124,8 @@
     {
         Address localAddress;
         socket->GetSockName(localAddress);
-        m_rxTrace(packet);
+        m_rxTraceWithoutAddress(packet);
+        m_rxTrace(packet, from);
         m_rxTraceWithAddresses(packet, from, localAddress);
         if (InetSocketAddress::IsMatchingType(from))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-echo-server.h ns-3.47/src/applications/model/udp-echo-server.h
--- ns-3.46/src/applications/model/udp-echo-server.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-echo-server.h	2026-02-16 16:08:49.572229900 -0800
@@ -16,7 +16,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 
 /**
@@ -45,8 +44,7 @@
     ~UdpEchoServer() override;
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
 
     /**
      * @brief Handle a packet reception.
@@ -57,12 +55,7 @@
      */
     void HandleRead(Ptr<Socket> socket);
 
-    uint8_t m_tos;         //!< The packets Type of Service
-    Ptr<Socket> m_socket;  //!< Socket
-    Ptr<Socket> m_socket6; //!< IPv6 Socket (used if only port is specified)
-
-    /// Callbacks for tracing the packet Rx events
-    TracedCallback<Ptr<const Packet>> m_rxTrace;
+    uint8_t m_tos; //!< The packets Type of Service
 
     /// Callbacks for tracing the packet Rx events, includes source and destination addresses
     TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_rxTraceWithAddresses;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-server.cc ns-3.47/src/applications/model/udp-server.cc
--- ns-3.46/src/applications/model/udp-server.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-server.cc	2026-02-16 16:08:49.572229900 -0800
@@ -45,10 +45,6 @@
                           MakeUintegerAccessor(&UdpServer::GetPacketWindowSize,
                                                &UdpServer::SetPacketWindowSize),
                           MakeUintegerChecker<uint16_t>(8, 256))
-            .AddTraceSource("Rx",
-                            "A packet has been received",
-                            MakeTraceSourceAccessor(&UdpServer::m_rxTrace),
-                            "ns3::Packet::TracedCallback")
             .AddTraceSource("RxWithAddresses",
                             "A packet has been received",
                             MakeTraceSourceAccessor(&UdpServer::m_rxTraceWithAddresses),
@@ -57,13 +53,10 @@
 }
 
 UdpServer::UdpServer()
-    : SinkApplication(DEFAULT_PORT),
-      m_socket{nullptr},
-      m_socket6{nullptr},
-      m_received{0},
-      m_lossCounter{0}
+    : SinkApplication(DEFAULT_PORT)
 {
     NS_LOG_FUNCTION(this);
+    m_protocolTid = TypeId::LookupByName("ns3::UdpSocketFactory");
 }
 
 UdpServer::~UdpServer()
@@ -74,7 +67,6 @@
 uint16_t
 UdpServer::GetPacketWindowSize() const
 {
-    NS_LOG_FUNCTION(this);
     return m_lossCounter.GetBitMapSize();
 }
 
@@ -88,60 +80,46 @@
 uint32_t
 UdpServer::GetLost() const
 {
-    NS_LOG_FUNCTION(this);
     return m_lossCounter.GetLost();
 }
 
 uint64_t
 UdpServer::GetReceived() const
 {
-    NS_LOG_FUNCTION(this);
     return m_received;
 }
 
 void
-UdpServer::StartApplication()
+UdpServer::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
 
-    if (!m_socket)
+    auto local = m_local;
+    if (local.IsInvalid())
     {
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket = Socket::CreateSocket(GetNode(), tid);
-        auto local = m_local;
-        if (local.IsInvalid())
-        {
-            local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
-            NS_LOG_INFO(this << " Binding on port " << m_port << " / " << local << ".");
-        }
-        else
-        {
-            if (InetSocketAddress::IsMatchingType(m_local))
-            {
-                const auto ipv4 = InetSocketAddress::ConvertFrom(m_local).GetIpv4();
-                NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << m_local
-                                 << ".");
-            }
-            else if (Ipv6Address::IsMatchingType(m_local))
-            {
-                const auto ipv6 = Inet6SocketAddress::ConvertFrom(m_local).GetIpv6();
-                NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << m_local
-                                 << ".");
-            }
-        }
-        if (m_socket->Bind(local) == -1)
-        {
-            NS_FATAL_ERROR("Failed to bind socket");
-        }
-        m_socket->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
+        local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+        NS_LOG_INFO(this << " Binding on port " << m_port << " / " << local << ".");
     }
+    else if (InetSocketAddress::IsMatchingType(m_local))
+    {
+        const auto ipv4 = InetSocketAddress::ConvertFrom(m_local).GetIpv4();
+        NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << m_local
+                         << ".");
+    }
+    else if (Ipv6Address::IsMatchingType(m_local))
+    {
+        const auto ipv6 = Inet6SocketAddress::ConvertFrom(m_local).GetIpv6();
+        NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << m_local
+                         << ".");
+    }
+    if (m_socket->Bind(local) == -1)
+    {
+        NS_FATAL_ERROR("Failed to bind socket");
+    }
+    m_socket->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
 
-    if (m_local.IsInvalid() && !m_socket6)
+    if (m_local.IsInvalid())
     {
-        // local address is not specified, so create another socket to also listen to all IPv6
-        // addresses
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket6 = Socket::CreateSocket(GetNode(), tid);
         auto local = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
         if (m_socket6->Bind(local) == -1)
         {
@@ -152,21 +130,6 @@
 }
 
 void
-UdpServer::StopApplication()
-{
-    NS_LOG_FUNCTION(this);
-
-    if (m_socket)
-    {
-        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    }
-    if (m_socket6)
-    {
-        m_socket6->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    }
-}
-
-void
 UdpServer::HandleRead(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
@@ -175,7 +138,8 @@
     {
         Address localAddress;
         socket->GetSockName(localAddress);
-        m_rxTrace(packet);
+        m_rxTraceWithoutAddress(packet);
+        m_rxTrace(packet, from);
         m_rxTraceWithAddresses(packet, from, localAddress);
         if (packet->GetSize() > 0)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-server.h ns-3.47/src/applications/model/udp-server.h
--- ns-3.46/src/applications/model/udp-server.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-server.h	2026-02-16 16:08:49.572229900 -0800
@@ -75,8 +75,7 @@
     void SetPacketWindowSize(uint16_t size);
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
 
     /**
      * @brief Handle a packet reception.
@@ -87,13 +86,8 @@
      */
     void HandleRead(Ptr<Socket> socket);
 
-    Ptr<Socket> m_socket;            //!< Socket
-    Ptr<Socket> m_socket6;           //!< IPv6 Socket (used if only port is specified)
-    uint64_t m_received;             //!< Number of received packets
-    PacketLossCounter m_lossCounter; //!< Lost packet counter
-
-    /// Callbacks for tracing the packet Rx events
-    TracedCallback<Ptr<const Packet>> m_rxTrace;
+    uint64_t m_received{0};             //!< Number of received packets
+    PacketLossCounter m_lossCounter{0}; //!< Lost packet counter
 
     /// Callbacks for tracing the packet Rx events, includes source and destination addresses
     TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_rxTraceWithAddresses;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-trace-client.cc ns-3.47/src/applications/model/udp-trace-client.cc
--- ns-3.46/src/applications/model/udp-trace-client.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-trace-client.cc	2026-02-16 16:08:49.572229900 -0800
@@ -102,13 +102,10 @@
 }
 
 UdpTraceClient::UdpTraceClient()
-    : m_sent{0},
-      m_socket{nullptr},
-      m_peerPort{},
-      m_sendEvent{},
-      m_currentEntry{0}
+    : SourceApplication(false)
 {
     NS_LOG_FUNCTION(this);
+    m_protocolTid = TypeId::LookupByName("ns3::UdpSocketFactory");
 }
 
 UdpTraceClient::~UdpTraceClient()
@@ -195,9 +192,8 @@
 }
 
 uint16_t
-UdpTraceClient::GetMaxPacketSize()
+UdpTraceClient::GetMaxPacketSize() const
 {
-    NS_LOG_FUNCTION(this);
     return m_maxPacketSize;
 }
 
@@ -280,58 +276,15 @@
 }
 
 void
-UdpTraceClient::StartApplication()
+UdpTraceClient::DoStartApplication()
 {
     NS_LOG_FUNCTION(this);
-
-    if (!m_socket)
-    {
-        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-        m_socket = Socket::CreateSocket(GetNode(), tid);
-        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
-        if (!m_local.IsInvalid())
-        {
-            NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
-                             InetSocketAddress::IsMatchingType(m_local)) ||
-                                (InetSocketAddress::IsMatchingType(m_peer) &&
-                                 Inet6SocketAddress::IsMatchingType(m_local)),
-                            "Incompatible peer and local address IP version");
-            if (m_socket->Bind(m_local) == -1)
-            {
-                NS_FATAL_ERROR("Failed to bind socket");
-            }
-        }
-        else
-        {
-            if (InetSocketAddress::IsMatchingType(m_peer))
-            {
-                if (m_socket->Bind() == -1)
-                {
-                    NS_FATAL_ERROR("Failed to bind socket");
-                }
-            }
-            else if (Inet6SocketAddress::IsMatchingType(m_peer))
-            {
-                if (m_socket->Bind6() == -1)
-                {
-                    NS_FATAL_ERROR("Failed to bind socket");
-                }
-            }
-            else
-            {
-                NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
-            }
-        }
-        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-        m_socket->Connect(m_peer);
-        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-        m_socket->SetAllowBroadcast(true);
-    }
+    m_socket->SetAllowBroadcast(true);
     m_sendEvent = Simulator::ScheduleNow(&UdpTraceClient::Send, this);
 }
 
 void
-UdpTraceClient::StopApplication()
+UdpTraceClient::CancelEvents()
 {
     NS_LOG_FUNCTION(this);
     Simulator::Cancel(m_sendEvent);
@@ -369,6 +322,7 @@
     }
 #endif
 
+    m_txTrace(p);
     if ((m_socket->Send(p)) >= 0)
     {
         ++m_sent;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/udp-trace-client.h ns-3.47/src/applications/model/udp-trace-client.h
--- ns-3.46/src/applications/model/udp-trace-client.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/udp-trace-client.h	2026-02-16 16:08:49.572229900 -0800
@@ -22,7 +22,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 
 /**
@@ -87,7 +86,7 @@
      * @brief Return the maximum packet size
      * @return the maximum packet size
      */
-    uint16_t GetMaxPacketSize();
+    uint16_t GetMaxPacketSize() const;
 
     /**
      * @brief Set the maximum packet size
@@ -102,8 +101,8 @@
     void SetTraceLoop(bool traceLoop);
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
+    void CancelEvents() override;
 
     /**
      * @brief Set the remote port (temporary function until deprecated attributes are removed)
@@ -156,13 +155,12 @@
         char frameType;      //!< Frame type (I, P or B)
     };
 
-    uint32_t m_sent;                    //!< Counter for sent packets
-    Ptr<Socket> m_socket;               //!< Socket
+    uint32_t m_sent{0};                 //!< Counter for sent packets
     std::optional<uint16_t> m_peerPort; //!< Remote peer port (deprecated) // NS_DEPRECATED_3_44
     EventId m_sendEvent;                //!< Event to send the next packet
 
     std::vector<TraceEntry> m_entries;    //!< Entries in the trace to send
-    uint32_t m_currentEntry;              //!< Current entry index
+    uint32_t m_currentEntry{0};           //!< Current entry index
     static TraceEntry g_defaultEntries[]; //!< Default trace to send
     uint16_t m_maxPacketSize; //!< Maximum packet size to send (including the SeqTsHeader)
     bool m_traceLoop;         //!< Loop through the trace file
